﻿Imports System.IO
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.Threading

Public Class Form1

    Dim ClntSocket As Socket            ' 通信用ソケット
    Dim ClntStream As NetworkStream     ' ネットワークストリーム
    Dim ClntReader As StreamReader
    Dim ClntWriter As StreamWriter
    Dim CommThread As Thread            ' 通信用スレッド

    Delegate Sub DisplayDlgt(ByVal s As String)
    Delegate Function MsgDlgt(ByVal owner As IWin32Window, _
                              ByVal s As String, ByVal cptn As String, _
                              ByVal btn As MessageBoxButtons, _
                              ByVal icn As MessageBoxIcon)

    ' 接続ボタンの処理
    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) _
                                                        Handles Button2.Click
        Dim SvrHostEntry As IPHostEntry
        Dim SvrAddress As IPAddress = Nothing
        Dim SvrPort As Integer = 50000
        Dim SvrEndPoint As EndPoint
        Dim i As Integer

        Try
            ClntSocket = New Socket(AddressFamily.InterNetwork, _
                                    SocketType.Stream, ProtocolType.Tcp)
            SvrHostEntry = Dns.GetHostEntry(TextBox2.Text)
            ' IPV4対応のIPアドレスをアドレスリストから検索
            For i = 0 To SvrHostEntry.AddressList.Length - 1
                If SvrHostEntry.AddressList(i).AddressFamily = AddressFamily.InterNetwork Then
                    SvrAddress = SvrHostEntry.AddressList(i)
                End If
            Next
            SvrEndPoint = New IPEndPoint(SvrAddress, SvrPort)
            ClntSocket.Connect(SvrEndPoint)
            ClntStream = New NetworkStream(ClntSocket)
            ClntReader = New StreamReader(ClntStream, Encoding.UTF8)
            ClntWriter = New StreamWriter(ClntStream, Encoding.UTF8)
            ClntWriter.NewLine = vbNewLine
            ClntWriter.AutoFlush = True
            ' 通信用スレッドの起動
            CommThread = New Thread(AddressOf ClntCommThread)
            CommThread.IsBackground = True
            CommThread.Start()
        Catch ex As Exception
            MessageBox.Show(Me, ex.Message, "接続エラー", _
                            MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ' 送信ボタンの処理
    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) _
                                                        Handles Button1.Click
        Try
            ClntWriter.WriteLine(TextBox1.Text)
        Catch ex As Exception
            MessageBox.Show(Me, ex.Message, "送信エラー", _
                            MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ' リストボックスにデータを表示
    Private Sub Display(ByVal s As String)
        ListBox1.Items.Add(s)
    End Sub
    ' 通信用スレッド
    Private Sub ClntCommThread()
        Dim Buffer As String
        Try
            Do
                Buffer = ClntReader.ReadLine()
                If IsNothing(Buffer) Then
                    Exit Do
                End If
                Me.Invoke(New DisplayDlgt(AddressOf Display), Buffer)
            Loop
            '通信の終了処理を行う
            ClntSocket.Shutdown(SocketShutdown.Both)
            CloseSocket()
        Catch ex As Exception
            Me.Invoke(New MsgDlgt(AddressOf MessageBox.Show), _
                      New Object() {Me, ex.Message, "通信スレッドエラー", _
                                    MessageBoxButtons.OK, MessageBoxIcon.Error})
        End Try
    End Sub
    ' 切断処理
    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) _
                                                        Handles Button3.Click
        ' 送信を無効にし，ソケットを閉じる
        ClntSocket.Shutdown(SocketShutdown.Send)
        If Not CommThread.Join(2000) Then
            CloseSocket()
        End If
    End Sub
    ' 通信の終了処理
    Private Sub CloseSocket()
        '  ネットワークストリームとソケットを閉じる
        If Not IsNothing(ClntStream) Then
            ClntStream.Close()
        End If
        If Not IsNothing(ClntSocket) Then
            ClntSocket.Close()
        End If
    End Sub
End Class
